with Stringpack; use Stringpack;
procedure Exception_Demo6 is

   task T1;
   task T2 is
      entry Hallo;
   end T2;

   task body T1 is
   begin
      for I in 1..3 loop
         T2.Hallo;
      end loop;

   exception
      when others => Print("t1: Fehler in rendezvous");
   end T1;

   task body T2 is
      function F return Natural is begin return 0; end F;
      N: Natural;
   begin
      for I in 1..3 loop
         accept Hallo do
            N := 1 mod F;     -- 1/0 in Rendezvous

         exception
            when Constraint_Error => Print("t2: Fehler in rendezvous");
         end Hallo;
      end loop;
   end T2;

begin
   null;
exception
   when Constraint_Error => Print("main: Fehler in rendezvous");
end Exception_Demo6;
